/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2006 satoshi akabane(akabane@logical-paradox.org)
 * $Id: MultiplicationOperation.java,v 1.4 2006/10/21 08:55:30 akabane Exp $
 */
package org.logical_paradox.petitbasic.operator;

import org.logical_paradox.petitbasic.lex.Token;
import org.logical_paradox.petitbasic.runtime.BasicRuntimeContext;
import org.logical_paradox.petitbasic.runtime.ErrorCodeConstant;
import org.logical_paradox.petitbasic.runtime.exception.BasicLanguageException;
import org.logical_paradox.petitbasic.runtime.mathpack.Real;

/**
 * ZZqD
 * PƑQZĕԂD
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.4 $
 */
public class MultiplicationOperation implements Operation {
	/**
	 * ZsD
	 * @param ctx BASIC^CReLXg
	 * @param v1 P(PZq̏ꍇnull)
	 * @param v2 Q
	 * @return vZ
	 * @throws BasicLanguageException vZɔG[Ȃ
	 */
	public Token doOperation(BasicRuntimeContext context, Token v1, Token v2) throws BasicLanguageException {
		if(OperationUtils.isStringValueType(v1.getValueType(), v2.getValueType(), context.getDefaultVarType())) {
			// ^̂type mismatch
			throw new BasicLanguageException(ErrorCodeConstant.TYPE_MISMATCH);
		}
		Token token = new Token(Token.TYPE_LITERAL);
		token.setDecimalFormat(Token.DF_INT);

		if(v1.getValueType() == Token.VTYPE_INT && v2.getValueType() == Token.VTYPE_INT) {
			// m͐ŌvZ
			token.setIntValue(v1.getIntValue() * v2.getIntValue());
			token.setValueType(Token.VTYPE_INT);
		} else {
			// ̏ꍇBCDZ
			Real r1 = OperationUtils.realValue(v1, context);
			Real r2 = OperationUtils.realValue(v2, context);
			Real answer = context.config.mathpack.fp_MUL(r1, r2);
			token.setRealValue(answer);
			token.setValueType(Token.VTYPE_DBL);
		}

		return token;
	}

}
